Ext.namespace("SYNO.SDS.TeamViewer.Lang");
Ext.namespace("SYNO.SDS.TeamViewer.Utils");

Ext.apply(SYNO.SDS.TeamViewer.Lang, {
	deviceInfo: "Device Information",
	welcome : "Welcome to Synology",
	welcomeText : "Before you can access your Synology NAS in TeamViewer, you have to assign it to your free TeamViewer account.",
	thirdParty: "Third Party Licenses",
	createAccount: "Create Account",
	alreadyHaveAccount: "Already have an account",
	loggedInYourAccount: "Please make sure that you are logged in to your TeamViewer client with your TeamViewer account. Then navigate to your \"Computers and Contacts\" tab.",
	isInTheSameNetwork: "If your Synology NAS is in the same network as your TeamViewer client, you can add it by using the \"Nearby contacts and devices\" function.",
	isNOTinTheSameNetwork: "If your Synology NAS is not in the same network as your TeamViewer client, you can add it manually by using the \"Add remote computer\" function.",
	notDeviceNearby: "I don't have my device located nearby",
	enterTemviewerID: "Enter the TeamViewer ID",
	pressOK: "and press \"OK\"",
	selectDevice: "Now select the NAS device in your \"Computers and Contacts\" list and assign it to your TeamViewer account.",
	askPersonalPassword: "When asked for the personal password, please use",
	successfulAssignment: "After a successful assignment, you can remotely connect to your Synology NAS directly from the \"Computers and Contacts\" list in your TeamViewer client.",
	yourID: "YOUR ID",
	password: "PASSWORD FOR ASSIGNMENT",
	assignedTo: "ASSIGNED TO",
	removeAssignment: "Remove Assignment",
	serviceIsOffline: "TeamViewer service is offline",
	remoteTerminal: "REMOTE TERMINAL",
	on: "ON",
	off: "OFF",
	instruction: "Instruction",
	descriptionText1: "This device has an assigned manager and only the manager has rights to access or share this device with other users.",
	descriptionText2: "If you have admin rights on this device, you can make this device unassigned by clicking \"Remove Assignment\". Then you can add the device again by using the above ID and generated Password.",
	noManager: "No manager assigned",
	moreInfo: "More information",
	downloadSupport: "Download Support Information",
	restarting: "Restarting TeamViewer service, please wait...",
	unableObtain: "Unable to obtain TeamViewer information, please restart TeamViewer",
	back:"Back",
	next:"Next",
	done: "Done",
	reason: "Reason",
	errorDeviceInfo: "Error in getting Device Info.",
	errorUnregisteringDevice: "Error in unregistering device manager.",
	errorDownload: "Error in downloading support file",
	errorInDisableTerminal: "Error in disabling Remote Terminal",
	errorInEnableleTerminal: "Error in enabling Remote Terminal",
	doYouWantToDisable: "Do you want to disable Remote Terminal?",
	doYouWantToEnable: "Do you want to enable Remote Terminal?",
	okInDisableTerminal: "Remote Terminal disabled",
	okInEnableleTerminal: "Remote Terminal enabled",
	noteLoggedInTeamviewer: "Note: If you are logged in via TeamViewer then your TeamViewer session will be closed.",
	unassignedDevice : "Do you want this device to be unassigned?",
	unassignedDeviceNote :'Note: If you are logged in via TeamViewer then your TeamViewer session will be closed and you won\'t be able to connect to your Synology until you assign it to your account again.',
	howAssign : 'How to connect to your Synology NAS with TeamViewer?',
	youCan2: "You can now remotely connect to your Synology NAS from the \"Computers and Contacts\" list in your TeamViewer account.",
	youCan1: "You can now assign this Synology NAS to your TeamViewer account by using the assignment information below.",
	additionalInformation: 'Additional information about TeamViewer benefits and licensing for Synology devices can be found',
	here : 'here!',
	assignInfo: 'Assignment Information'
});

Ext.apply(SYNO.SDS.TeamViewer.Utils, function(){
	var TeamViewerURL = null;
	var imgURL = '';
	var lang = SYNO.SDS.TeamViewer.Lang;
	var deviceInfo = {};
	var updateUI = true;
	var selectedSlide = 0 ;
	var isNotDeviceNearby = false;
	var isTerminalEnabled = false;
	var managerName = '';
	var teamViewerID = 0;
	var ADDITIONAL_INFO_URL = "https://www.teamviewer.com/link/?url=767094";
	var CREATE_ACCOUNT_URL = "https://login.teamviewer.com/LogOn#register";

 	// private functions start
	var setHeaderText = function(text){
		document.getElementById("headerText").innerHTML = text;
	};

	var setDeviceInfoHtml = function(){
		document.getElementById("header").innerHTML = lang.deviceInfo;
		setHeaderText(lang.youCan1);
		document.getElementById('headerText').style.marginTop='10px';
		var paragraph_clear = '<p style="clear: both;"></p>';
		var separator = '<div style="height: 3px;margin-bottom: 5px; border-bottom:1px solid #E6E6E6"></div>';

		// Start div TV_ID
		var html = '<p id="assignInfoId" style="font-size: 16px;margin:15px 0 0 0; color: #030303;">'+ lang.assignInfo+'</p>';
		html += '<div style="margin-top:15px">';
		html += rightArrowRectangle(lang.yourID);
		html += '<div id="TV_ID" class="selectabletext" style="font-size:21px;float:right;"> - </div>';
		html += paragraph_clear;
		html += separator;
		html += '</div>';
		// End TV_ID

		// Start div password_area
		html += '<div id="password_area" style=" display: block;">';
		html += rightArrowRectangle(lang.password);
		html += '<div id="TV_Pass" class="selectabletext" style="font-size:21px;float:right;"> - </div>';
		html += paragraph_clear;
		html += separator;
		html += '</div>';
		// End div password_area

		// Start div manager_area
		html += '<div id="manager_area" style="display:none">';
		html += rightArrowRectangle(lang.assignedTo);
		html += '<div id="TV_Manager" class="selectabletext" style="font-size:21px;float:right;"></div>';
		html += paragraph_clear;
		html += separator;
		html += '</div>';
		html += '<span id="TV_UnregisterManagerContainer" style="display:none;float:right">';
		html += '<button id="TV_UnregisterManager" style="cursor: pointer;background-color:#ffffff;border:none;color:#4390EA;font-size:12px;font-weight:200;text-decoration:underline;" type="button">';
		html += lang.removeAssignment;
		html += '</button></span>';
		// End div manager_area

		html += '<p id="ConnMsg" style="font-size:12px;font-weight:400; color:#ff0000; display:none; margin:0 ;height:14px">';
		html += lang.serviceIsOffline;
		html += '</p>';

		//Start remoteTerminal
		html += paragraph_clear;
		html += getRemoteTerminalHTML();
		//End remoteTerminal

		html += paragraph_clear;
		html += '<div id="deviceInstructionID"></div>';
		html += '<p style="position: absolute; bottom: 100px;"><a id="downloadSupportId" style="text-decoration: none; color: #3D92EA; border-bottom: 1px solid #3D92EA;" href="#">';
		html += lang.downloadSupport;
		html += '</a></p>';
		document.getElementById("content").innerHTML = html;
		setDisableManagerInstruction();

		document.getElementById("TV_UnregisterManager").addEventListener("click", function(){
			SYNO.SDS.TeamViewer.Utils.unregisterDeviceManager();
		});
		document.getElementById("TV_TerminalButton").addEventListener("click", function(){
			SYNO.SDS.TeamViewer.Utils.terminalButton();
		});
		document.getElementById("downloadSupportId").addEventListener("click", function(){
			SYNO.SDS.TeamViewer.Utils.downloadSupportFile();
		});
		SYNO.SDS.TeamViewer.Utils.getDeviceInfo(refreshDeviceInfo);
	};

	var getRemoteTerminalHTML = function(){
		if(isTerminalEnabled){
			buttonEnabledDisplay = 'block';
			buttonDisabledDisplay = 'none';
		}else{
			buttonEnabledDisplay = 'none';
			buttonDisabledDisplay = 'block';
		}
		var html = '<div id="TV_RemoteTerminal" style="display:block; margin-top:20px;opacity:0.4">';
		html += rightArrowRectangle(lang.remoteTerminal);
		html += '<div style="height:24px; float:right; width:55px; border-radius:15px; position:relative">';
		html += '<div id="TV_TerminalButtonDisabled" style="display:';
		html += buttonDisabledDisplay;
		html +='; background-color:#f0f0f0; height:24px; float:right; width:55px;vertical-align:middle; color:#ffffff;  border-radius:15px; border: 1px solid #3D92EA; position:relative">';
		html += '<div style="height:16px; width:16px; float:left; background-color:transparent; background-color:#ffffff; border: 1px #3D92EA solid;border-radius: 50%; margin-top:3px; margin-left:5px; position:absolute"></div>';
		html += '<div style="height:24px; width:20px; float:right; background-color:transparent; border:none; margin-right:10px; margin-top: 6px; color:#3D92EA;">' + lang.off + '</div>';
		html += '</div>';
		html += '<div id="TV_TerminalButtonEnabled" style="display:';
		html += buttonEnabledDisplay;
		html += '; background-color:#3D92EA; height:24px; float:right; width:55px;vertical-align:middle; color:#ffffff;  border-radius:15px; border: 1px solid #3D92EA; position:relative">';
		html += '<div style="height:24px; width:20px; float:left;  border:none; margin-left: 6px;margin-top: 5px; color:#ffffff;">' + lang.on + '</div>';
		html += '<div style="height:16px; width:16px; float:right; background-color:#ffffff; border-radius: 50%; margin-top:3px; margin-right:5px; border:1px Lavender solid" ></div>';
		html += '</div>';
		html += '<button id="TV_TerminalButton" style="background-color:transparent; border:none; height:100%; width:100%;vertical-align:middle;position:absolute; top:0; border-radius:15px;" disabled></button>';
		html += '</div></div>';
		return html;
	};

	var rightArrowRectangle = function(text){
		var html ='<div style="font-size: 12px; height:11px; background-color: #3D92EA; padding: 7px ;color: #ffffff; float: left; ">';
		html += text;
		html += '</div>';
		html +='<div style="width: 0;height: 0;float: left;border-top: 13px solid transparent; border-bottom: 12px solid transparent; border-left: 13px solid #3D92EA;"></div>';
		return html;
	};

	var setDisableManagerInstruction = function(){
		setHeaderText(lang.youCan1);
		document.getElementById('assignInfoId').style.display = "block";
		var html = '<div style="margin-top:35px">';
		html +='<p style="margin: 0;"><a id="howToConnectId" style="text-decoration: none; color: #3D92EA; border-bottom: 1px solid #3D92EA;" href="#">';
		html += lang.howAssign;
		html += '</a></p>';
		html += '<p style="margin: 25px 0 0 0;">';
		html += lang.additionalInformation;
		html += ' <a target="_blank" style="text-decoration: none; color: #3D92EA; border-bottom: 1px solid #3D92EA;" href="';
		html += ADDITIONAL_INFO_URL +'">';
		html += lang.here;
		html += '</a></p></div>';
		document.getElementById("deviceInstructionID").innerHTML = html;
		document.getElementById("howToConnectId").addEventListener("click", function(){
			SYNO.SDS.TeamViewer.Utils.setWelcomeHTML();
		});
	};

	var setEnableManagerInstruction = function(){
		setHeaderText(lang.youCan2);
		document.getElementById('assignInfoId').style.display = "none";
		var html = '<div style="margin-top:17px"><p style="font-size:16px;font-weight:300;color:#030303;margin-top:10px;margin-bottom:10px">' + lang.instruction + '</p>';
		html += '<p style="margin: 0;">' + lang.descriptionText1 + '</p>';
		html += '<p style="margin-top:10px;">' + lang.descriptionText2 + '</p></div>';
		document.getElementById("deviceInstructionID").innerHTML = html;
	};

	var getRequest = function(params, success, failure){
		Ext.Ajax.request({
			url: TeamViewerURL + "/TeamViewerWebSupport.cgi",
			scope: this,
			method: "GET",
			params: 'method=' + params,
			success: success,
			failure: failure});
	};

	var alert= function(type, msg){
		SYNO.SDS.TeamViewer.Utils.ApplicationWindow && SYNO.SDS.TeamViewer.Utils.ApplicationWindow.getMsgBox().alert(_T(type,"error_error"),msg);
	};

	var confirm = function(msg, callback){
		SYNO.SDS.TeamViewer.Utils.ApplicationWindow && SYNO.SDS.TeamViewer.Utils.ApplicationWindow.getMsgBox().confirm('TeamViewer', msg, callback, this);
	};

	var setTimeOutFunc = function(callback){
		SYNO.SDS.TeamViewer.TimeOutID = setTimeout(function(){
			SYNO.SDS.TeamViewer.Utils.getDeviceInfo(callback);
		}, 5000);
	};

	var setSlideOne = function(){
		selectedSlide = 1;
		setHeaderText(lang.loggedInYourAccount);
		document.getElementById("img_container").innerHTML = "<div style='margin-top:10px;'><img src='" + imgURL + "img2.svg'><div>";
		activeSlide(0);
	};

	var setSlideTwo = function(){
		isNotDeviceNearby = false;
		var notDeviceNearby = '<div id="notDeviceNearby" style="width: 220px;cursor: pointer;margin-top:15px ;margin-bottom:10px; padding: 6px 10px;font-size: 12px;background-color: #FFFFFF; border: 1px solid #3D92EA; color: #3D92EA; border-radius: 2px;font-weight: bold;">'
		+lang.notDeviceNearby
		+'</div>';
		setHeaderText(lang.isInTheSameNetwork);
		document.getElementById("img_container").innerHTML = notDeviceNearby
		+ '<img style="width:240px;" src="' + imgURL + 'img3-1.svg"><img style="position: absolute;margin-left: 35px;" src="' + imgURL + 'img3-2.svg">';
		document.getElementById("notDeviceNearby").addEventListener("click", function(){
			SYNO.SDS.TeamViewer.Utils.notDeviceNearbyOnClick();
		});
		document.getElementById("next").innerHTML = lang.next;
		activeSlide(1);
	};

	var setSlideThree = function(){
		setHeaderText(lang.isNOTinTheSameNetwork);
		document.getElementById("img_container").innerHTML = "<div style='margin-top:30px'><img src='" + imgURL + "img4-1.svg'>"
		+ "<span style='position: absolute; margin-left: 20px;'><p style='margin: 0 0 3px 0;'>"
		+ lang.enterTemviewerID
		+ "</p><p style='margin: 0 0 3px 0; font-weight: bold;'>" + getTeamViewerID() +"</p><p style='margin: 0'>"
		+ lang.pressOK + "</p><img style='margin-top:10px;' src='" + imgURL + "img4-2.svg'></span></div>";
		activeSlide(2);
	};

	var setSlideFour = function(){
		setHeaderText(lang.selectDevice);
		document.getElementById("img_container").innerHTML = "<div style='margin-top:30px'><img src='" + imgURL + "img5-1.svg'>"
		+ "<span style='position: absolute; margin-left: 20px;'><p style='margin: 0 0 3px 0'>"
		+ lang.askPersonalPassword + "</p><p style='margin: 0 0 3px 0; font-weight: bold;'>"
		+ SYNO.SDS.TeamViewer.SynologySerial +
		"</p><img src='" + imgURL + "img5-2.svg' style='margin-top: 10px;'></span></div>";
		document.getElementById("next").innerHTML = lang.next;
		activeSlide(3);
	};

	var setSlideFive = function(){
		setHeaderText(lang.successfulAssignment);
		var html = "<div style='margin-top:30px'><img src='";
		html += imgURL;
		html += "img6-1.svg'><img src='";
		html +=  imgURL;
		html += "img6-2.svg' style='position: absolute;'>";
		html += "</div>";
		document.getElementById("img_container").innerHTML = html;
		document.getElementById("next").innerHTML = lang.done;
		activeSlide(4);
	};

	//add white space as thousands separators.For example '2 021 949 890'
	var getTeamViewerID = function(){
		return teamViewerID ? teamViewerID.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " "):'-';
	};

	var activeSlide = function(index){
		var  dots = document.getElementById("dotContainer").children;
		var selectedDot = document.getElementsByClassName("selectedDot")[0];
		if(selectedDot){
			selectedDot.className= "";
			selectedDot.style.backgroundColor = "#E8EAED";
		}
		dots[index].classList.add("selectedDot");
		dots[index].style.backgroundColor = "#3D92EA";
	};

	var setDeviceInfoData = function(info){
		deviceInfo = info;
		if(info){
			managerName = info.ManagerName;
			teamViewerID = info.TeamViewerID;
		}
	};

	var refreshDeviceInfo = function(response){
		if(response && response.responseText){
			setDeviceInfoData(Ext.util.JSON.decode(response.responseText, true));
		}
		if(updateUI === true){
			setDeviceInfo(response);
		}
		setTimeOutFunc(refreshDeviceInfo);
	};

	var updateDeviceInfoPage = function(){
		SYNO.SDS.TeamViewer.Utils.getDeviceInfo(refreshDeviceInfo);
	};

	var setDeviceInfo = function(response){
		var connMsg = document.getElementById("ConnMsg");
		if(response && response.responseText){
			if(deviceInfo.DaemonStatus && deviceInfo.DaemonStatus.localeCompare("Restart") == 0){
				connMsg.innerHTML = lang.restarting;
				defaultState();
			}
			else if(teamViewerID && deviceInfo.Status.localeCompare("Online") == 0){
				setTVID(getTeamViewerID());
				managerName === "" ? disableManagerArea() : enableManagerArea();
				connMsg.style.display = "none";
			}else{
				connMsg.innerHTML = lang.serviceIsOffline;
				defaultState();
			}
			var terminalStatus = (Number(deviceInfo.RemoteTerminalStatus) != 0);
			if(terminalStatus != isTerminalEnabled){
				terminalStatus ? enableRemoteTerminal() : disableRemoteTerminal();
			}
		}else{
			connMsg.innerHTML = lang.unableObtain;
			defaultState();
			disableRemoteTerminal();
			disableRemoteTerminalButton();
		}
	};

	var disableManagerArea = function(){
		document.getElementById("password_area").style.display = "block";
		document.getElementById("manager_area").style.display = "none";
		document.getElementById("TV_Pass").innerHTML = SYNO.SDS.TeamViewer.SynologySerial;
		document.getElementById("TV_Manager").innerHTML = lang.noManager;
		document.getElementById("TV_UnregisterManagerContainer").style.display = "none";
		disableRemoteTerminalButton();
		setDisableManagerInstruction();
	};

	var isDeviceInfoPage = function(){
		return !!document.getElementById("password_area");
	};

	var enableManagerArea = function(){
		var unregisterManagerContainer = document.getElementById("TV_UnregisterManagerContainer");
		document.getElementById("password_area").style.display = "none";
		document.getElementById("manager_area").style.display = "block";
		document.getElementById("TV_Pass").innerHTML = "-";
		document.getElementById("TV_Manager").innerHTML = managerName;
		document.getElementById("TV_RemoteTerminal").style.opacity = "1";
		setEnableManagerInstruction();
		if(true === _S("is_admin")){
			unregisterManagerContainer.style.visibility = "visible";
			unregisterManagerContainer.style.display = "inline-block";
			document.getElementById("TV_UnregisterManager").disabled = false;
			document.getElementById("TV_TerminalButton").disabled = false;
		}
	};

	var setTVID = function(id){
		document.getElementById("TV_ID").innerHTML = id;
	};

	var defaultState = function(){
		document.getElementById("TV_Pass").innerHTML = "-";
		setTVID("-");
		document.getElementById("password_area").style.display = "block";
		document.getElementById("manager_area").style.display = "none";
		document.getElementById("ConnMsg").style.display = "block";
		document.getElementById("TV_UnregisterManagerContainer").style.visibility = "hidden";
		disableRemoteTerminalButton();
		setDisableManagerInstruction();
	};

	var enableRemoteTerminalButton = function(){
		document.getElementById("TV_RemoteTerminal").style.opacity = "1";
		document.getElementById("TV_TerminalButton").disabled = false;
	};

	var disableRemoteTerminalButton = function(){
		document.getElementById("TV_RemoteTerminal").style.opacity = "0.4";
		document.getElementById("TV_TerminalButton").disabled = true;
	};

	var disableUnregisterManager = function(){
		clearTimeout(SYNO.SDS.TeamViewer.TimeOutID);
		updateUI = false;
		document.getElementById("TV_UnregisterManager").disabled = true;
		disableRemoteTerminalButton();
		document.getElementById("ConnMsg").innerHTML = lang.restarting;
		defaultState();
	};

    var enableUnregisterManager = function(){
		document.getElementById("TV_UnregisterManager").disabled = false;
		enableRemoteTerminalButton();
	};

	var enableRemoteTerminal = function(){
		isTerminalEnabled = true;
		document.getElementById("TV_TerminalButtonEnabled").style.display = "block";
		document.getElementById("TV_TerminalButtonDisabled").style.display = "none";
	};

	var disableRemoteTerminal = function(){
		isTerminalEnabled = false;
		var terminalButtonDisabled = document.getElementById("TV_TerminalButtonDisabled");
		document.getElementById("TV_TerminalButtonEnabled").style.display = "none";
		terminalButtonDisabled.style.display = "block";
		terminalButtonDisabled.style.borderColor = "#3D92EA";
	};

	var setContent = function(){
		teamViewerID && managerName
					 ? setDeviceInfoHtml()
					 : SYNO.SDS.TeamViewer.Utils.setWelcomeHTML();
	};
	// private functions end

	//public functions
	return{

		constructor : function(response){
			if(response && response.responseText){
				setDeviceInfoData(Ext.util.JSON.decode(response.responseText, true));
			}
			setContent();
			document.getElementById("TVThirdPartyLicense").addEventListener("click", function(){
				SYNO.SDS.TeamViewer.Utils.thirdPartyLicense();
			});
		},

		getMainHtml: function(){
			var html = '<div style="height: 100%;position:relative; padding: 30px 15px 15px 15px; font:13px Arial;line-height:1.3 ; color:#5C5B62">';
			html += '<p id="header"  style="font-size: 22px;margin: 0 0 0 0; color: #030303;"></p>';
			html += '<div>';
			html += '<p id="headerText" style="margin-top: 20px;"></p>';
			html += '<div id="content"></div></div>';
			html += '<div style="position: absolute; bottom: 60px; width: 93%; border-top:1px solid #E6E6E6; padding-top: 10px;">';
			html += '<a id="TVThirdPartyLicense" href="#" style="text-decoration: none; color: #3D92EA;	border-bottom: 1px solid #3D92EA; ">'+ lang.thirdParty +'</a>';
			html += '<a target="_blank" href="https://www.TeamViewer.com" style="float: right; text-decoration: none; color: #3D92EA; border-bottom: 1px solid #3D92EA;">www.teamviewer.com</a></div>';
			return html += '</div>';
		},

		setWelcomeHTML : function(){
			selectedSlide = 0;
			document.getElementById('header').innerHTML = lang.welcome;
			document.getElementById('headerText').style.marginTop='20px';
			setHeaderText(lang.welcomeText);

			var html = '<div style="padding-top: 30px;"><a style="padding: 10px 15px 10px 15px;font-weight: bold;background-color: #3D92EA;color: #ffffff;height: 44px; border-radius:5px; text-decoration:none;" target="_blank" href="';
			html += CREATE_ACCOUNT_URL + '">';
			html += lang.createAccount + '</div>';
			html += '<p style="float: right; cursor: pointer; margin-top: 220px; color: #3D92EA; font-weight: bold;"><a  id="alreadyHaveAccount">' + lang.alreadyHaveAccount + '</a></p></div>';
			document.getElementById('content').innerHTML = html;

			document.getElementById("alreadyHaveAccount").addEventListener("click", function(){
				SYNO.SDS.TeamViewer.Utils.setWizardHtml();
			});
		},

		setWizardHtml: function(){
			setHeaderText(lang.loggedInYourAccount);
			var firstDot;
			var welcomeContent = document.getElementById("content");
			var dot = '<div style="height: 7px; width: 7px; margin-right: 7px; background-color: #E8EAED; border-radius: 50%; display: inline-block;"></div>';
			var html ='<div id="img_container" style="width: 100%; position: absolute;"></div>';

			html += '<div style=" position: absolute;font-size: 11px;width: 93%; bottom: 120px;">';
			html += '<a id="back" ';
			html += 'style="cursor: pointer;display: inline-block;padding: 6px 24px;border-radius: 2px;color: #3D92EA;background-color: white;border: 1px solid #DADCE0;">';
			html += lang.back+'</a>';
			html += '<div id="dotContainer" style="margin-left: 104px;display: inline-block;text-align: center;padding-top: 7px;">';
			html += dot + dot + dot + dot + dot;
			html += '</div>';
			html += '<a id="next" ';
			html += 'style="cursor: pointer;display: inline-block; padding: 6px 24px; border-radius: 2px; float :right; color: white; background-color: #3D92EA;">';
			html += lang.next+'</a>';
			html += '</div>';

			welcomeContent.innerHTML = html;
			//set slide
			setSlideOne();
			//

			document.getElementById("back").addEventListener("click", function(){
				SYNO.SDS.TeamViewer.Utils.showSlides(-1);
			});

			document.getElementById("next").addEventListener("click", function(){
				SYNO.SDS.TeamViewer.Utils.showSlides(1);
			});
		},

		notDeviceNearbyOnClick : function(){
			isNotDeviceNearby = true;
			this.showSlides(1);
		},

		showSlides: function(incr){
			selectedSlide += incr;
			if(selectedSlide == 3 && !isNotDeviceNearby && incr === 1){
				selectedSlide = 5;
			}

			if(selectedSlide === 4 && !isNotDeviceNearby && incr === -1){
				selectedSlide = 2;
			}
			var setSlideFunction = [ SYNO.SDS.TeamViewer.Utils.setWelcomeHTML,setSlideOne,setSlideTwo,setSlideThree,setSlideFour,setSlideFive,setDeviceInfoHtml];
			setSlideFunction[selectedSlide]();
		},

		downloadSupportFile: function(){
			getRequest("DownloadSupportFile",
						function(response){
							try {
								Ext.destroy(Ext.get('tv-downloadIframe'));
							}
							catch(e) {}
							Ext.DomHelper.append(document.body, {
								tag: 'iframe',
								id: 'tv-downloadIframe',
								frameBorder: 0,
								width: 0,
								height: 0,
								css: 'display:none;visibility:hidden;height:0px;',
								src: TeamViewerURL + "/" + response.responseText
							});
						},
						function(response, connection){
							alert("error",lang.errorDownload +'\n' + lang.reason+ ': ' + response.statusText);
						}
					);
		},

		unregisterDeviceManager : function(){
			if(true === _S("is_admin")){
				var msg = lang.unassignedDevice + '</br><span style="font-size:0.9em">'+ lang.unassignedDeviceNote+'</span>';
				var errorMsg = lang.errorUnregisteringDevice + '\n' + lang.reason+ ': ';
				confirm(
					msg,
					function(btn){
						if("yes" === btn){
							disableUnregisterManager();
							getRequest(
								"UnregisterDeviceManager",
								function(response){
									var isDeviceInfo = isDeviceInfoPage();
									if(response){
										if("success" === response.responseText){
											managerName = "";
										} else {
											if(isDeviceInfo){
												enableUnregisterManager();
											}
											alert("error", errorMsg + response.responseText);
										}
									}
									updateUI = true;
									if(isDeviceInfo){
										updateDeviceInfoPage();
									}
								},
								function(response){
									if(response){
										alert("error", errorMsg + response.statusText);
									}
									updateUI = true;
									if(!isDeviceInfoPage()) return;
									enableUnregisterManager();
									updateDeviceInfoPage();
								});
						}
					}
				);
			}
		},

		terminalButton: function(){
			if(true === _S("is_admin")){
				var askRemoteTerminal, method, errorMsg, okMsg, success;
				if(isTerminalEnabled){
					askRemoteTerminal = lang.doYouWantToDisable;
					errorMsg = lang.errorInDisableTerminal;
					okMsg = lang.okInDisableTerminal;
					method = "DisableRemoteTerminal";
					success = disableRemoteTerminal;
				}else{
					askRemoteTerminal = lang.doYouWantToEnable;
					errorMsg = lang.errorInEnableleTerminal;
					okMsg = lang.okInEnableleTerminal;
					method = "EnableRemoteTerminal";
					success = enableRemoteTerminal;
				}

				confirm(
					askRemoteTerminal +'</br><span style="font-size:0.9em">' + lang.noteLoggedInTeamviewer + '</span>',
					function(btn){
						if("yes" === btn){
							disableUnregisterManager();
							getRequest(
								method,
								function(response){
									var isDeviceInfo = isDeviceInfoPage();
									if(response){
										updateUI = true;
										alert("info", okMsg);
										if(!isDeviceInfo) return;
										success();
										enableRemoteTerminalButton();
									}
									if(isDeviceInfo) updateDeviceInfoPage();
								},
								function(response){
									if(response){
										alert("info", errorMsg + '\n' + lang.reason+ ': ' + response.statusText);
									}
									updateUI = true;
									if(!isDeviceInfoPage()) return;
									enableRemoteTerminalButton();
									updateDeviceInfoPage();
								}
							);
						}
					}
				);
			}
		},

		thirdPartyLicense: function(){
			try{
				Ext.destroy(Ext.get('tv-licenseIframe'));
			}
			catch(e){}
			Ext.DomHelper.append(document.body, {
				tag: 'iframe',
				id:'tv-licenseIframe',
				frameBorder: 0,
				width: 0,
				height: 0,
				css: 'display:none;visibility:hidden;height:0px;',
				src: TeamViewerURL + "/TeamViewerWebSupport.cgi?_dc=" + (new Date().getTime()) + "&SynoToken=" + SYNO.SDS.Session.SynoToken + "&method=ThirdPartyLicense"
			});
		},

		getDeviceInfo : function(callback){
			getRequest(
				"GetDeviceInfo",
				callback,
				function(response){
					if(response){
						if(response.status == "403" || response.status == "401"){
							alert("error", lang.errorDeviceInfo + "\nStatus: " + response.status + "\n" + lang.reason + ": " + response.statusText);
						}else{
							//Don't show the alert box for this error message. User should not be aware of these kinds of events.
							console.log(lang.errorDeviceInfo + "\nStatus: " + response.status + "\n" + lang.reason + ": " + response.statusText);
							setTimeOutFunc(callback);
						}
					}
				}
			);
		},

		setTeamViewerURL : function(url){
			TeamViewerURL = url;
			imgURL = url + '/images/';
		}
	}
}());

Ext.define("SYNO.SDS.TeamViewer.Application", {
	extend: "SYNO.SDS.AppInstance",
	appWindowName: "SYNO.SDS.TeamViewer.MainWindow",
	constructor: function(){
		this.callParent(arguments);
	}
});
 
Ext.define("SYNO.SDS.TeamViewer.MainWindow", {
	extend: "SYNO.SDS.AppWindow",
	constructor : function(a){
		var TV = SYNO.SDS.TeamViewer;
		this.appInstance = a.appInstance;
		TV.MainWindow.superclass.constructor.call(this, Ext.apply({
			layout : "fit",
			resizable : false,
			cls: "syno-tv-win",
			maximizable : false,
			minimizable : true,
			width : 450,
			height : 512,
			html: TV.Utils.getMainHtml()
		}, a));
		TV.SynologySerial = "-";
		TV.Utils.ApplicationWindow = this;
		TV.Utils.setTeamViewerURL(window.location.href.slice(0, window.location.href.lastIndexOf("/")) + "/" + this.jsConfig.jsBaseURL);
		TV.Utils.getDeviceInfo(TV.Utils.constructor);
		this.getDSInfo();
	},

	onOpen : function(){
		SYNO.SDS.TeamViewer.MainWindow.superclass.onOpen.apply(this, arguments);
	},

	getDSInfo: function() {
		this.sendWebAPI({
			api: "SYNO.Core.System",
			method: "info",
			version: this.getDsmVersion() >= "6.0" ? 2: 1,
			callback: function(status, data, a){
				if(status === false){
					console.log("getDSInfo: Failed to get Synology Info");
					return;
				}
				SYNO.SDS.TeamViewer.SynologySerial = data.serial;
			},
			scope: this
		});
	},
	onRequest : function(a){
		SYNO.SDS.TeamViewer.MainWindow.superclass.onRequest.call(this, a);
	},

	onClose : function(){
		clearTimeout(SYNO.SDS.TeamViewer.TimeOutID);
		SYNO.SDS.TeamViewer.TimeOutID = undefined;
		SYNO.SDS.TeamViewer.MainWindow.superclass.onClose.apply(this, arguments);
		this.doClose();
		return true;
	}
});